/*
	Personal WishList
	Copyright (c) 2005 Edward Anastas - Some rights reserved
	http://www.wishcentral.com/

*/

// global request and XML document objects
var req;

var currentVersion = getKeyValue("info.plist", "CFBundleVersion");
var udpate = new Array;


// retrieve XML document (reusable generic function);
// parameter is URL string (relative or complete) to
// an .xml file whose Content-Type is a valid XML
// type, such as text/xml; XML source must be from
// same domain as HTML file
function checkVersion() {
	
	url = "http://wishcentral.com/dashboard/personalwishlist/PersonalWishlist.xml";
	
	// branch for native XMLHttpRequest object
	if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
		req.onreadystatechange = processVersionData;
		req.open("GET", url, true);
		req.send();
		// branch for IE/Windows ActiveX version
	} else if (window.ActiveXObject) {
		isIE = true;
		req = new ActiveXObject("Microsoft.XMLHTTP");
		if (req) {
			req.onreadystatechange = processVersionData;
			req.open("GET", url, true);
			req.send();
		}
	}
}

function processVersionData() {
	
	if ( req.readyState == 4 ) { // if request completed
		
		var versionData = req.responseXML.getElementsByTagName("widget")[0];
		
		udpate['title'] = versionData.getElementsByTagName("title").item(0).firstChild.nodeValue;
		udpate['link'] = versionData.getElementsByTagName("link").item(0).firstChild.nodeValue;
		udpate['version'] = versionData.getElementsByTagName("version").item(0).firstChild.nodeValue;
		
		//document.getElementById('description').value = "udpateVersion: " + udpate['version'] + " : " + currentVersion;
		
		if ( currentVersion < udpate['version']) {
			showUpdate(udpate);
		}
		
		
		
	} else {
		if ( window.widget ) {
			//document.getElementById('description').value = "status: " + req.statusText + " ("+ req.readyState +")";
		} else {
			alert("There was a problem retrieving the XML data:\n" +
				req.statusText);
		}
	}
}

function showUpdate(udpate) {
	
	toggleUpdateElements(true); // show autoUpdate
	
	updateVersionText.innerText = "Version "+ udpate['version'] +" is available!";
	currentVersionText.innerText = "(you currently have version "+ currentVersion +")";
	
}


function hideUpdate() {
	
	toggleUpdateElements(false);
	
}



function toggleUpdateElements(showUpdate) {
	
	if (showUpdate) { // open updater
		var toggleMain = "hidden";
		var toggleUpdate = "visible";
	} else { // close updater
		var toggleMain = "visible";
		var toggleUpdate = "hidden";
	}
	
	document.getElementById("autoUpdate").style.visibility = toggleUpdate;
	document.getElementById("updated").style.visibility = toggleMain;
	
}

// much appreciation for the following function
// this code submitted by Chris from dashboardwidgets.com Thanks!
// http://www.dashboardwidgets.com/forums/viewtopic.php?t=689
function getKeyValue(plist, key) {
	
	var infoPlist = new XMLHttpRequest();
	infoPlist.open("GET", plist, false);
	infoPlist.send(null);
	
	
	//var xml = infoPlist.responseXML.getElementsByTagName("dict");
	
	var xml = infoPlist.responseXML;
	var keys = xml.getElementsByTagName("key");
	var vals = xml.getElementsByTagName("string");
	var key_value;
	
	//for (var i in se) { // future implementation
	for (var i=0; i < keys.length; i++) {
		if (keys[i].firstChild.data == key) {
			key_value = vals[i].firstChild.data;
			break;
		}
	}
	//infoPlist.abort(null);
	return key_value;
}


function downloadUpdate() {
	
	widget.system("mv ~/Library/Widgets/PersonalWishlist.wdgt ~/.Trash/PersonalWishlist_" + currentVersion + ".wdgt", null);
	
	if ( udpate['link'].length < 1 ) {
		url = "http://www.wishcentral.com/dashboard/personalwishlist/?autoupdate=1";
	} else {
		url = udpate['link'];
	}
	
	wrapURL(url);
	
}
